{
  "version": "6",
  "dialect": "sqlite",
  "id": "05b549e7-5b3f-40f4-9461-05db59391e20",
  "prevId": "6651137c-a198-4538-86be-7cb8b88ca998",
  "tables": {
    "character_abilities": {
      "name": "character_abilities",
      "columns": {
        "character": {
          "name": "character",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "ability": {
          "name": "ability",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "value": {
          "name": "value",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": 0
        },
        "max": {
          "name": "max",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": 0
        }
      },
      "indexes": {},
      "foreignKeys": {
        "character_abilities_character_character_id_fk": {
          "name": "character_abilities_character_character_id_fk",
          "tableFrom": "character_abilities",
          "tableTo": "character",
          "columnsFrom": [
            "character"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "character_abilities_character_ability_pk": {
          "columns": [
            "character",
            "ability"
          ],
          "name": "character_abilities_character_ability_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "character_choices": {
      "name": "character_choices",
      "columns": {
        "character": {
          "name": "character",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "id": {
          "name": "id",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "choice": {
          "name": "choice",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "character_choices_character_character_id_fk": {
          "name": "character_choices_character_character_id_fk",
          "tableFrom": "character_choices",
          "tableTo": "character",
          "columnsFrom": [
            "character"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "character_choices_character_id_choice_pk": {
          "columns": [
            "character",
            "id",
            "choice"
          ],
          "name": "character_choices_character_id_choice_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "character_leveling": {
      "name": "character_leveling",
      "columns": {
        "character": {
          "name": "character",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "level": {
          "name": "level",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "choice": {
          "name": "choice",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "character_leveling_character_character_id_fk": {
          "name": "character_leveling_character_character_id_fk",
          "tableFrom": "character_leveling",
          "tableTo": "character",
          "columnsFrom": [
            "character"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "character_leveling_character_level_pk": {
          "columns": [
            "character",
            "level"
          ],
          "name": "character_leveling_character_level_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "character": {
      "name": "character",
      "columns": {
        "id": {
          "name": "id",
          "type": "integer",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": true
        },
        "name": {
          "name": "name",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "owner": {
          "name": "owner",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "people": {
          "name": "people",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "level": {
          "name": "level",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": 1
        },
        "variables": {
          "name": "variables",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": "'{}'"
        },
        "aspect": {
          "name": "aspect",
          "type": "integer",
          "primaryKey": false,
          "notNull": false,
          "autoincrement": false
        },
        "notes": {
          "name": "notes",
          "type": "text",
          "primaryKey": false,
          "notNull": false,
          "autoincrement": false
        },
        "visibility": {
          "name": "visibility",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": "'private'"
        },
        "thumbnail": {
          "name": "thumbnail",
          "type": "blob",
          "primaryKey": false,
          "notNull": false,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "character_owner_users_id_fk": {
          "name": "character_owner_users_id_fk",
          "tableFrom": "character",
          "tableTo": "users",
          "columnsFrom": [
            "owner"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "character_training": {
      "name": "character_training",
      "columns": {
        "character": {
          "name": "character",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "stat": {
          "name": "stat",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "level": {
          "name": "level",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "choice": {
          "name": "choice",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "character_training_character_character_id_fk": {
          "name": "character_training_character_character_id_fk",
          "tableFrom": "character_training",
          "tableTo": "character",
          "columnsFrom": [
            "character"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "character_training_character_stat_level_pk": {
          "columns": [
            "character",
            "stat",
            "level"
          ],
          "name": "character_training_character_stat_level_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "email_validation": {
      "name": "email_validation",
      "columns": {
        "id": {
          "name": "id",
          "type": "text",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": false
        },
        "timestamp": {
          "name": "timestamp",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {},
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "project_content": {
      "name": "project_content",
      "columns": {
        "id": {
          "name": "id",
          "type": "text",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": false
        },
        "content": {
          "name": "content",
          "type": "blob",
          "primaryKey": false,
          "notNull": false,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {},
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "project_files": {
      "name": "project_files",
      "columns": {
        "id": {
          "name": "id",
          "type": "text",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": false
        },
        "path": {
          "name": "path",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "owner": {
          "name": "owner",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "title": {
          "name": "title",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "type": {
          "name": "type",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "navigable": {
          "name": "navigable",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": true
        },
        "private": {
          "name": "private",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": false
        },
        "order": {
          "name": "order",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "timestamp": {
          "name": "timestamp",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {
        "project_files_path_unique": {
          "name": "project_files_path_unique",
          "columns": [
            "path"
          ],
          "isUnique": true
        }
      },
      "foreignKeys": {
        "project_files_owner_users_id_fk": {
          "name": "project_files_owner_users_id_fk",
          "tableFrom": "project_files",
          "tableTo": "users",
          "columnsFrom": [
            "owner"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "user_permissions": {
      "name": "user_permissions",
      "columns": {
        "id": {
          "name": "id",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "permission": {
          "name": "permission",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "user_permissions_id_users_id_fk": {
          "name": "user_permissions_id_users_id_fk",
          "tableFrom": "user_permissions",
          "tableTo": "users",
          "columnsFrom": [
            "id"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "user_permissions_id_permission_pk": {
          "columns": [
            "id",
            "permission"
          ],
          "name": "user_permissions_id_permission_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "user_sessions": {
      "name": "user_sessions",
      "columns": {
        "id": {
          "name": "id",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "user_id": {
          "name": "user_id",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "timestamp": {
          "name": "timestamp",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "user_sessions_user_id_users_id_fk": {
          "name": "user_sessions_user_id_users_id_fk",
          "tableFrom": "user_sessions",
          "tableTo": "users",
          "columnsFrom": [
            "user_id"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {
        "user_sessions_id_user_id_pk": {
          "columns": [
            "id",
            "user_id"
          ],
          "name": "user_sessions_id_user_id_pk"
        }
      },
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "users_data": {
      "name": "users_data",
      "columns": {
        "id": {
          "name": "id",
          "type": "integer",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": false
        },
        "signin": {
          "name": "signin",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "lastTimestamp": {
          "name": "lastTimestamp",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        }
      },
      "indexes": {},
      "foreignKeys": {
        "users_data_id_users_id_fk": {
          "name": "users_data_id_users_id_fk",
          "tableFrom": "users_data",
          "tableTo": "users",
          "columnsFrom": [
            "id"
          ],
          "columnsTo": [
            "id"
          ],
          "onDelete": "cascade",
          "onUpdate": "cascade"
        }
      },
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    },
    "users": {
      "name": "users",
      "columns": {
        "id": {
          "name": "id",
          "type": "integer",
          "primaryKey": true,
          "notNull": true,
          "autoincrement": true
        },
        "username": {
          "name": "username",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "email": {
          "name": "email",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "hash": {
          "name": "hash",
          "type": "text",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false
        },
        "state": {
          "name": "state",
          "type": "integer",
          "primaryKey": false,
          "notNull": true,
          "autoincrement": false,
          "default": 0
        }
      },
      "indexes": {
        "users_username_unique": {
          "name": "users_username_unique",
          "columns": [
            "username"
          ],
          "isUnique": true
        },
        "users_email_unique": {
          "name": "users_email_unique",
          "columns": [
            "email"
          ],
          "isUnique": true
        },
        "users_hash_unique": {
          "name": "users_hash_unique",
          "columns": [
            "hash"
          ],
          "isUnique": true
        }
      },
      "foreignKeys": {},
      "compositePrimaryKeys": {},
      "uniqueConstraints": {},
      "checkConstraints": {}
    }
  },
  "views": {},
  "enums": {},
  "_meta": {
    "schemas": {},
    "tables": {},
    "columns": {}
  },
  "internal": {
    "indexes": {}
  }
}